OpenGL appendProto(GLU) appendProto(GLUT)

Font appendProto(OpenGL)

Font drawCenteredString := method(text, width,
    glTranslatei(((width - self widthOfString(text)) / 2), 0, 0)
    drawString(text)
)
        
Font drawOffsetString := method(text, offset,
    glTranslatei(offset, 0, 0)
    drawString(text)
)

GLApp := Object clone do(
    appendProto(OpenGL)
    newSlot("height", 0)
    newSlot("width", 0)
    
    reshape := method(w, h,
	height = h
	width = w
	glViewport(0, 0, w, h)
	glLoadIdentity
	gluOrtho2D(0, w, 0, h)
	glutPostRedisplay
    )
    
    draw := method(Nop)
    
    display := method(
	glClearColor(0, 0, 0, 1)
	glClear(GL_COLOR_BUFFER_BIT)
	glPushMatrix
	draw
	glPopMatrix    
	glFlush
	glutSwapBuffers
    )

    keyboard := method(k, x, y,
	GLUT_KEY_ESC := 27
	if (k == GLUT_KEY_ESC,    self ?escapeKey)
	if (k == GLUT_KEY_SPACE,  self ?spaceKey)
	if (k == GLUT_KEY_RETURN, self ?returnKey)
	display
    )

    special := method(c, x, y,
	if (c == GLUT_KEY_UP,   self ?specialUpKey)
	if (c == GLUT_KEY_DOWN, self ?specialDownKey)
	display
    )

    escapeKey := method(
	if(isFullScreen) then (
	    glutLeaveGameMode
	    glutInitWindowSize(640, 480)
	    glutInitWindowPosition(0, 0)	    
	    glutCreateWindow("Slides")
	    isFullScreen = Nil
	) else(
	    glutDestroyWindow(glutWindowId)
	    glutEnterGameMode
	    glutEventTarget(Slideshow)
	    glutDisplayFunc
	    glutReshapeFunc
	    glutKeyboardFunc
	    glutSpecialFunc
	    isFullScreen = 1
	)
    )

    mouse := method(Nop)

    newSlot("gameModeString", "1600x1200:32@60") // "1024x768:32@60"
    newSlot("appName", "io") 

    runFullScreen := method(
	self isFullScreen := 1
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutInit
	glutGameModeString(gameModeString)
	glutEnterGameMode
	initEvents
	initBlending
	glutMainLoop
    )

    run := method(
	self isFullScreen := Nil
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutInitWindowSize(640, 480)
	glutInitWindowPosition(0, 0)
	glutInit
	self glutWindowId := glutCreateWindow(appName)
	initEvents
	initBlending
	glutMainLoop
    )

    initBlending := method(
	glColor4d(0, 0, 0, 1)
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
    )

    initEvents := method(
	glutEventTarget(self)
	glutDisplayFunc
	glutReshapeFunc
	glutKeyboardFunc
	glutSpecialFunc
	glutMouseFunc
    )
)
