/*
 *	Experimental rewrite
 */

#include "IoGLE.h"

#include "base/List.h"
#include "IoState.h"
#include "IoNumber.h"
#include "IoCFunction.h"
#include "IoNil.h"
#include "IoSeq.h"
#include "IoList.h"
#include "List.h"
#include "IoVector.h"
#include <time.h>

#define DATA(self) ((IoGLEData *)self->data)

IoTag *IoGLE_tag(void *state)
{
  IoTag *tag = IoTag_newWithName_("GLE");
  tag->state = state;
  tag->cloneFunc = (TagCloneFunc *)IoGLE_rawClone;
  /*
  tag->freeFunc  = (TagFreeFunc *)IoGLE_free;
  tag->markFunc  = (TagMarkFunc *)IoGLE_mark;
  */
  return tag;
}

IoGLE *IoGLE_proto(void *state)
{
  IoObject *self = IoObject_new(state);
  self->tag = IoGLE_tag(state);
  /*self->data = calloc(1, sizeof(IoGLEData));*/

  IoState_registerProtoWithFunc_(state, self, IoGLE_proto);
  IoGLE_protoInit(self);
  return self;
}

IoGLE *IoGLE_new(void *state)
{ return IoState_protoWithInitFunction_(state, IoGLE_proto); }

/*
void IoGLE_free(IoGLE *self) 
{ }

void IoGLE_mark(IoGLE *self)
{}
*/

/* ----------------------------------------------------------- */

IoObject *IoGLE_rawClone(IoGLE *self)
{ 
    return IoState_protoWithInitFunction_(IOSTATE, IoGLE_proto); 
}

/* --- GLE -------------------------------------------------------- */

#define IOCFUNCTION_GLE(func) IOCFUNCTION(func, NULL)

#include "IoGLEconst.h"
#include "IoGLEfunc.h"

void IoGLE_protoInit(IoGLE *self) 
{ 
  IoObject_setSlot_to_(self, IOSYMBOL("clone"), IOCFUNCTION_GLE(IoObject_self));
  
  /* GLE Constants */
  {
   t_ioGLE_constTable *curpos=ioGLE_constTable;
   while (curpos->name) {
    IoObject_setSlot_to_(self, IOSYMBOL(curpos->name), IONUMBER(curpos->value));
    curpos++;
   }
  }

  /* GLE Functions */
  {
   t_ioGLE_funcTable *curpos=ioGLE_funcTable;
   while (curpos->name) {
    IoObject_setSlot_to_(self, IOSYMBOL(curpos->name), IOCFUNCTION_GLE(curpos->func));
    curpos++;
   }
  }
}
