
Arena := Object clone do(
  players := List clone
  newObjects := List clone
  objects := List clone
  deadObjects := List clone
  camera := Camera clone
  message := "MEANWHILE..."
  messageTimer := 200
  focusObject := Nil
  
    newPlayer  := method(
	player := Player clone
	players append(player)
	addObject(player)
	if (players size == 1, focusObject(players at(1)))
	player
    )

    addObject  := method(anObject,
	newObjects atPut(anObject, 1)
	 anObject
    )

    focusObject := method(anObject, 
	focusObject = anObject
	//anObject isAI(0)
    )

    addNewObjects := method(
	newObjects foreach(newObject, objects atPut(newObject, 1))
	//newObjects = ?????
    )

    removeObject := method(anObject,
	deadObjects atPut(anObject, 1)
	anObject
    )

    chooseNewFocus := method(
	objects foreach(object,
	    if (object proto == Player, focusObject(object); return )
	)
	newGame
    )

    newGame := method(
	write("average frames per second := "..framerate)
	WallManager reset
	
	self players := List clone
	self newObjects := List clone
	self objects := List clone
	self deadObjects := List clone
	
	newPlayer
	newPlayer:isAI(1)
	newPlayer:isAI(1)
	newPlayer:isAI(1)
	newPlayer:isAI(1)
    )

    hex := method(
	return floor(random*128*64).."x00"
    )

    removeDeadObjects := method(
	deadObjects foreach(deadObject,
	    objects atPut(deadObject, Nil)
	    if (deadObject.prototype == Player ) then (
		if (deadObject isAI== 1,  message("CYCLE PROGRAM "..self hex.." DEREZED") )
	    )
	    if (deadObject == focusObject ) then ( 
		newGame
		message("NEW MATCH...   FPS:"..framerate)
		if (getn(self deadObjects) == 0, return ) // new game started
	    )
	)
	deadObjects = List clone
	anObject
    )

    loadGLTextures := method(
	names := list( 
	"floor", 
	"rimwalla", 
	"rimwallb", 
	"rimwallc", 
	"rimwalld", 
	"gltroncrash", 
	"bike")

	names foreach(num, name, 
	     jpeg := Image clone
	    jpeg load("textures/"..name..".jpg")
	    textures atPut(name, Image textureId)

	    checkErrors(name)

	    glTexParameter(GLTEXTURE2D, GLTEXTUREMINFILTER, GLLINEARMIPMAPNEAREST)
	    glTexParameter(GLTEXTURE2D, GLTEXTUREMAGFILTER, GLLINEAR)
	    glTexParameter(GLTEXTURE2D, GLTEXTUREWRAPS, GLREPEAT)
	    glTexParameter(GLTEXTURE2D, GLTEXTUREWRAPT, GLREPEAT)
	)
    )

    InitGL := method(
	self loadGLTextures
	glEnable(GLTEXTURE2D)       	
	glShadeModel(GLSMOOTH)
	glClearColor(0.0, 0.0, 0.0, 0.0)
	glClearDepth(1.0)
	glEnable(GLDEPTHTEST)
	glHint(GLPERSPECTIVECORRECTIONHINT, GLNICEST)
	
	if (0==1 ) then (
	  glLight(GLLIGHT1, GLAMBIENT, ( 1, 1, 1, 1.0 ))
	  glLight(GLLIGHT1, GLDIFFUSE, ( 1.0, 1.0, 1.0, 1.0 ))
	  glLight(GLLIGHT1, GLPOSITION, ( 0.0, -1.0, 0.0, 10.0 ))
	  glEnable(GLLIGHT1)
	  glEnable(GLLIGHTING)
	)

	// resizeGLScene once to set up initial perspective
	resizeGLScene(100, 100)
	glFlush
    )

    draw := method(
	set3dPerspective
	glClear(GLCOLORBUFFERBIT | GLDEPTHBUFFERBIT)
	glLoadIdentity
	camera followPlayer(focusObject)
	camera look
	ArenaModel draw
	objects foreach(object, v, object draw)
	
	set2dPerspective
	showMessage
	glutSwapBuffers
    )

    // messages ////////////////////////////////////////////////

    showMessage := method(
	startFade := 100
	t :=  messageTimer
	a := ((t/startFade) min(1))
	if (t > 0 ) then (
	    messageTimer = t - 1
	    Font alpha(a)
	    size := message size min(floor((200-self messageTimer)/2.5) )
	    Font drawString(message substring(1, size))
	)

	if (1 == 0) then ( // attempted fade in from black...
	    glPushMatrix
	    glEnable(GLBLEND)
	    glColor(0,0,0, a)
	    glScale(winWidth, winHeight, 1)
	    Font drawCharacter(" ")
	    glBegin(GLQUADS)    
	    glVertex(0, 0, 0)
	    glVertex(0, 1, 0)
	    glVertex(1, 1, 0)
	    glVertex(0, 1, 0)
	    glEnd
	    glDisable(GLBLEND)
	    glPopMatrix
	    )
	)

    message := method(aString,
	messageTimer = 200
	message = aString
    )

    //////////////////////////////////////////////////

    keyboard := method(key, x, y, state,
	//print(key)
	if (state == GLUTKEYMODUP, return )
	players at(1) keyboard(key, x, y)
    )

    timeStep := method(
	objects foreach(object, v, object timeStep)
	camera timeStep
	draw
	addNewObjects
	removeDeadObjects
    )

    set2dPerspective := method(
	glMatrixMode(GLPROJECTION)
	glLoadIdentity
	gluOrtho2D(0, winWidth, 0, winHeight)
	glMatrixMode(GLMODELVIEW)
	glLoadIdentity
	glEnable(GLDEPTH)
    )

    set3dPerspective := method(
	glMatrixMode(GLPROJECTION)
	glLoadIdentity
	gluPerspective(45, winWidth / winHeight, 0.1, 100)
	glMatrixMode(GLMODELVIEW)
	glDisable(GLDEPTH)
    )


    // GLUT callbacks ////////////////////////////////////////////////////

    drawGLSceneArena draw := method(
    keyboard := method(key, x, y,state, Arena keyboard(key, x, y,state) )

    resizeGLScene := method(width, height,
	winWidth := max(1, width)
	winHeight := max(1, height)
	glViewport(0, 0, winWidth, winHeight)
    )

    //startTime := System Time hpsize
    frames := 0
     
    timer := method(value,
	frames := frames + 1
	glutTimerFunc(1, timer, 1) 
	glFinish
	Arena timeStep
    )

    framerate
      return floor(.5+(frames/((System.Time.hpsize-startTime)/1000000)))
    )

    special  := method( key, x, y, val ,
	if (key == lastkey ) then ( lastkey := key lastkey := 0 return )
	lastkey := key
	// left=100, up=101, right=102, down=103
    )

    key := key - 100
	if (key == 0 ) then ( // left
	    players at(1) keyboard(122, x, y)
	//elseif (key == 1 ) then ( // up
	elseif (key == 2 ) then ( // right
	    players at(1) keyboard(120, x, y)
	elseif (key == 3 ) then ( // down
	    players at(1):keyboard(98, x, y)
	// elseif (key == 4 ) then ( // page up
	// elseif (key == 5 ) then ( // page down
	)

    )
    special := method(key, x, y, val, Arena special  := method((key, x, y,val, ))

)
