
Camera := Object clone do(
    currentLocation := Nil
    idealLocation := Nil
    followPlayer := Nil 
    currentTarget := Nil
    idealTarget := Nil
    speed := 0
    normalSpeed := 0


    init := method(
      self currentLocation := Point clone set(0, 3, 0)
      self idealLocation   := Point clone set(0, 0, 0)
      self currentTarget   := Point clone set(0, 0, 0)
      self idealTarget     := Point clone set(0, 0, 0)
    )

    followPlayer  := method(aPlayer,
       x, y, z := aPlayer:xyz
      self idealTarget set(x, y, z)
      if (self followPlayer == Nil ) then ( self currentTarget set(x, y, z) )
      self followPlayer := aPlayer
      return self
    )

    idealTargetreturn  := method(self idealTarget)

    updateIdealTarget  := method(
	if (self followPlayer == Nil, return )
	s := self followPlayer.speed - self followPlayer.normalSpeed
	x, y, z := self followPlayer:xyz
	dx, dy, dz := self followPlayer dxdydzNormalized
	f := .2 //+ (s*10)
	self idealTarget set(x + dx * f, .1 + (s * 10), z + dz * f)
    )

    look  := method(
	x1, y1, z1 := self currentLocation:xyz
	px, py, pz := self currentTarget:xyz
	offset := .06
       gluLookAt(x1+ offset, y1, z1 + offset, px, py, pz, 0, 1, 0)
    )

    timeStep := method(
	updateIdealTarget
	updateCurrentLocation
	updateCurrentTarget
    )

    updateCurrentLocation := method(
	if (self followPlayer == Nil, return )
	s := self followPlayer.speed - self followPlayer.normalSpeed
	self currentLocation moveCloserTobyRatio(self followPlayer, .015)
	y := self currentLocation y
	self currentLocation setY(y + ((.5 - y) * .01) + a abs)
    )

    updateCurrentTarget := method(
       self currentTarget moveCloserTobyRatio(self idealTarget, .03, .01)
    )

)