//////////////////////////////////////////////////////
// WallManager
// hashes the cycle walls in the x and y axis for
// quick initial collision tests
//////////////////////////////////////////////////////

WallManager := Object clone do(
    xhash := List clone
    zhash := List clone
    div := 4

    init := method(
	xhash = List clone
	zhash = List clone
    )

    reset  := method(init)

    addWall := method(wall, rotY,          
	if (rotY % 180 != 0 ) then ( 
	
	    // wall on x axis, put in xhash
	    xh := ((wall x1 * div) floor)
	    h := xhash at(xh)
	    if (h == Nil ) then ( h := List clone; xhash atPut(xh, h) )
	    h atPut(wall, 1)
	    
	) else (
	
	    // wall on z axis, put in zhash
	    zh := floor(wall z1 * div)
	    h := zhash at(zh)
	    if (h == Nil ) then ( h := List clone; zhash atPut(zh, h) )
	    h atPut(wall, 1)  
	    
	)
    )

    removeWalls := method(walls,
	n := 1
	max := walls size + 1
	while (n < max,
	    wall := walls at(n)
	    h
	    h := wallsNearX(wall x1); if (h, h atPut(wall, Nil) )
	    h := wallsNearZ(wall z1); if (h, h atPut(wall, Nil) )
	    n := n + 1
	)
    )

    // near ////////////////////////////////////////////////////

    wallsNearX := method(x, xhash at((x * div) floor))
    wallsNearZ := method(z, zhash at((z * div) floor))

    // around ////////////////////////////////////////////////////

    wallsAroundX := method(x,
	xh := ((x * div) floor)
	List clone addSeq(xhash at(xh-1)) addSeq(xhash at(xh)) addSeq(xhash at(xh+1))
    )

    wallsAroundZ := method(z,
	zh := ((z * div) floor)
	List clone addSeq(zhash at(zh-1)) addSeq(zhash at(zh)) addSeq(zhash at(zh+1))
    )

)
