/*#io
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IoSkipDB_DEFINED
#define IoSkipDB_DEFINED 1

#include "Common.h"
#include "IoState.h"
#include "IoObject.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ISSKIPDB(self) \
  IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoSkipDB_rawClone)

typedef IoObject IoSkipDB;

IoSkipDB *IoSkipDB_proto(void *state);
IoSkipDB *IoSkipDB_rawClone(IoObject *self);
IoSkipDB *IoSkipDB_new(void *state);
IoSkipDB *IoSkipDB_newWithSDB(void *state, SkipDB *sdb);
void IoSkipDB_free(IoObject *self);
void IoSkipDB_mark(IoObject *self);

//void IoSkipDB_writeToStore_stream_(IoObject *self, IoStore *store, BStream *stream);
//void IoSkipDB_readFromStore_stream_(IoObject *self, IoStore *store, BStream *stream);

// -------------------------------------------------------- 

IoObject *IoSkipDB_headerPid(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoSkipDB_atPut(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoSkipDB_at(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoSkipDB_removeAt(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoSkipDB_size(IoObject *self, IoObject *locals, IoMessage *m);
IoObject *IoSkipDB_cursor(IoObject *self, IoObject *locals, IoMessage *m);

#ifdef __cplusplus
}
#endif
#endif
