/*
docCopyright("Steve Dekorte", 2002)
docLicense("BSD revised")
*/

#ifndef IOSOCKET_DEFINED
#define IOSOCKET_DEFINED 1

#include "IoObject.h"
#include "IoSeq.h"
#include "IoMessage.h"
#include "Socket.h"

#define ISSOCKET(self) IoObject_hasCloneFunc_(self, (TagCloneFunc *)IoSocket_rawClone)

typedef IoObject IoSocket;

IoSocket *IoMessage_locals_socketArgAt_(IoMessage *self, IoObject *locals, int n);

IoSocket *IoSocket_rawClone(IoSocket *self);
IoSocket *IoSocket_proto(void *state);
IoSocket *IoSocket_new(void *state);
IoSocket *IoSocket_newWithSocket_(void *state, Socket *socket);
void IoSocket_free(IoSocket *self);

// ----------------------------------------------------------- 

IoObject *IoSocket_descriptorId(IoSocket *self, IoObject *locals, IoMessage *m);
SOCKET_DESCRIPTOR IoSocket_rawDescriptor(IoSocket *self);

IoObject *IoSocket_streamOpen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_udpOpen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_isOpen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_isValid(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_isStream(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_close(IoSocket *self, IoObject *locals, IoMessage *m);

// client

IoObject *IoSocket_connectTo(IoSocket *self, IoObject *locals, IoMessage *m);

// stream

IoObject *IoSocket_streamRead(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_streamWrite(IoSocket *self, IoObject *locals, IoMessage *m);

// udp 

IoObject *IoSocket_udpRead(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_udpWrite(IoSocket *self, IoObject *locals, IoMessage *m);

// server

IoObject *IoSocket_bind(IoSocket *self, IoObject *locals, IoMessage *m);	
IoObject *IoSocket_listen(IoSocket *self, IoObject *locals, IoMessage *m);
IoObject *IoSocket_accept(IoSocket *self, IoObject *locals, IoMessage *m);

#endif
