
Event do(
	type := "Event"
	docCategory("Networking")
    newSlot("descriptorId", -1)
    newSlot("eventType", nil)
    newSlot("timeout", 10)
    newSlot("coro", nil) // internal
    EV_TIMER := 0
    
    debugWriteln := nil
    debugOff := method(self debugWriteln := nil)
    debugOn := method(self debugWriteln := getSlot("writeln"))
    //debugOn
    
    eventTypeName := method(
        if(eventType == EV_READ,   return "EV_READ")
        if(eventType == EV_WRITE,  return "EV_WRITE")
        if(eventType == EV_SIGNAL, return "EV_SIGNAL")
        if(eventType == EV_TIMER,  return "EV_TIMER")
        "?"  
    )
    
    handleEvent := method(isTimeout,
        //writeln("Event ", eventTypeName, " handleEvent(", isTimeout, ") for coro ", coro uniqueId)
        debugWriteln(coro label, " resuming - got ", eventTypeName)
        self isTimeout := isTimeout
        if(coro,
            tmpCoro := coro
            setCoro(nil)
            tmpCoro resumeLater
        )
    )
    
    waitOn := method(t,
        coroId := Scheduler currentCoroutine uniqueId //label
        if(t, setTimeout(t))
        //debugWriteln("Event ", eventTypeName, " waitOn with timeout ", timeout, " on coro ", coroId)
        //debugWriteln(coroId, " pausing for ", eventTypeName)
        if(coro, Exception raise("already waiting on this event"))
        if((descriptorId == -1) and(eventType != EV_TIMER), Exception raise("invalid descriptor"))
        setCoro(Scheduler currentCoroutine)
        EventManager addEvent(self, descriptorId, eventType, timeout)
        debugWriteln(Scheduler currentCoroutine uniqueId, " pausing for ", eventTypeName)
		coro setLabel(eventTypeName)
        coro pause
        debugWriteln(coroId, " unpaused on ", eventTypeName)
        //debugWriteln(coroId, " resuming after ", eventTypeName)
        isTimeout == false
    )
    
    waitOnOrExcept := method(t,
        waitOn(t)
        isTimeout ifTrue(Exception raise("timeout"))
    )
)

ReadEvent   := Event clone setEventType(Event EV_READ) do(
	type := "ReadEvent"
	docCategory("Networking")
)

WriteEvent  := Event clone setEventType(Event EV_WRITE) do(
	type := "WriteEvent"
	docCategory("Networking")
)

SignalEvent := Event clone setEventType(Event EV_SIGNAL) do(
	type := "SignalEvent"
	docCategory("Networking")
)

TimerEvent  := Event clone setEventType(Event EV_TIMER) do(
	type := "TimerEvent"
	docCategory("Networking")
)


EventManager  do(
	type := "EventManager"
	docCategory("Networking")
    isRunning := false
    
    run := method(coroDo(runLoop))
    
    runLoop := method(
    	Scheduler currentCoroutine setLabel("EventManager")
        if(isRunning, return)
        isRunning = true
            
        loop(
        	//events empty
            if(Coroutine yieldingCoros size == 0,  listenUntilEvent, listen)
            yield
        )
    )
)

EventManager setListenTimeout(0.03) run
