// for performance testing only

debugCollector := 1
SocketManager setSelectTimeout(0)
Scheduler setSleepInterval(0)

WebRequestHandler := Object clone do(
    mapForRequest := method(data,
	form := Map clone
	lines := data replaceSeq("\r", "") asString splitNoEmpties("\n")
	
	lines foreach(i, line, 
	    if (line containsSeq(":"), 
		key := line beforeSeq(":")
		value := line afterSeq(":") strip(" ")
		form atPut(key, value)
	    )
	)
		
	parts := lines first splitNoEmpties(" ")
	form atPut("method", parts at(0)) 
	form atPut("request", parts at(1))
	form
    )
    
    handleRequest := method(
	form := mapForRequest(socket readBuffer)
	path := form at("request")
	
	if (path lastPathComponent  == "/", path = path .. "index.html")
	path = Path with(server rootPath, path)
	socket write(server fileAtPath(path))    
    )
    
    handleSocketFromServer := method(aSocket, aServer,
	self socket := aSocket
	self server := aServer
	
	//aSocket isOpen ifNil(return)
	aSocket read
	if (aSocket error, writeln(aSocket error); return)
    
	aSocket isOpen ifNil(return)
	
	aSocket write("Content-type: text/plain\r\n\r\n")
	handleRequest
	aSocket close
    )
)

port := 8000
write("[Starting web server on port ", port , "]\n")

webServer := Server clone setPort(port) do(
    rootPath := "/Library/WebServer/iolanguage/"
    requestCount := 0
    handleSocket := method(aSocket,
	WebRequestHandler clone handleSocketFromServer(aSocket, self)
	requestCount = requestCount + 1
	//writeln(requestCount)
	if (requestCount % 1000 == 0, writeln(requestCount))
    )
    fileCache := Map clone
    fileAtPath := method(path,
	data := fileCache at(path)
	//if(data, return data)
	try(
		data := File clone setPath(path) asBuffer
	) catch(Exception, e,
		return path .. " document not found"
	)
	fileCache atPut(path, data)
	data
    )
)

webServer start
