//
// cwrapper.cpp - Binding for pitch and tempo resampling
//

#include "BPMDetect.h"
#include "BPMDetect_wrapper.h"

using namespace soundtouch;

void *BPMDetect_init(int numChannels, int sampleRate) 
{
    BPMDetect *bpmDetect = new BPMDetect(numChannels, sampleRate);
    return (void *)bpmDetect;
}

void BPMDetect_free(void *bpmd) 
{
    BPMDetect *bpmDetect = (BPMDetect *)bpmd;
    delete bpmDetect;
}

void BPMDetect_inputSamples(void *bpmd, float *samples, int numSamples) 
{
    BPMDetect *bpmDetect = (BPMDetect *)bpmd;
    bpmDetect->inputSamples(samples, numSamples);
}

float BPMDetect_getBpm(void *bpmd) 
{
    BPMDetect *bpmDetect = (BPMDetect *)bpmd;
    return bpmDetect->getBpm();
}
