#include "IoSimple.h"
#include "IoState.h"

IoTag *IoSimple_tag(void *state)
{
    IoTag *tag = IoTag_newWithName_("Simple");
    tag->state = state;
    tag->freeFunc  = (TagFreeFunc *)IoSimple_free;
    tag->cloneFunc = (TagCloneFunc *)IoSimple_rawClone;
    return tag;
}

IoSimple *IoSimple_proto(void *state)
{
	IoObject *self = IoObject_new(state);
   self->tag = IoSimple_tag(state);
   
   IoState_registerProtoWithFunc_(state, self, IoSimple_proto);
   
   {
		IoMethodTable methodTable[] = {
			{"message", IoSimple_message},
			{NULL, NULL},
		};
		IoObject_addMethodTable_(self, methodTable);
   }
	return self;
}

IoSimple *IoSimple_rawClone(IoSimple *proto) 
{ 
    IoObject *self = IoObject_rawClonePrimitive(proto);
    return self; 
}

IoSimple *IoSimple_new(void *state)
{
    IoSimple *proto = IoState_protoWithInitFunction_(state, IoSimple_proto);
    return IOCLONE(proto);
}

void IoSimple_free(IoSimple *self) 
{ 
}

/* ----------------------------------------------------------- */

IoObject *IoSimple_message(IoSimple *self, IoObject *locals, IoMessage *m)
{
	printf( "Hello World\n" );
   return self;
}

/* --- This isn't autogenerated, but I suppose it could be given sufficient convention. --- */

void IoSimpleInit(IoState *self, IoObject *context)
{
	IoObject_setSlot_to_(context, SIOSYMBOL("Simple"), IoSimple_proto(self));
}