//
//  IoState.m
//  IoLanguage
//
//  Created by Steve Dekorte on Mon Jul 26 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "IoStateController.h"
#import "IoVM.h"

//#import "IoServer.h"
//#import "IoDesktop.h"
#include "IoObjcBridge.h"

#include <unistd.h>

void IoDesktopInit(IoState *self, IoObject *context);

void *DoIoString(IoState *ioState, char *s, void *unused)
{
  return IoState_doCString_(ioState, s);
}

@implementation IoStateController

- launchPath
{
  return [[NSBundle mainBundle] resourcePath];
}

- chdirToLaunchPath
{
  chdir([[self launchPath] cString]);
}

- setLaunchPath
{ 
  NSString *s = [NSString stringWithFormat:@"launchPath := \"%@\"", [self launchPath]];
  return [self doString:s];
}

- init
{
  ioState = IoState_new();
  IoDesktopInit(ioState, ioState->lobby);
  
  [self chdirToLaunchPath];
  [self setLaunchPath];
}  

- (void)dealloc
{
  [lobby release];
  IoState_free(ioState);
}

- doString:(NSString *)s
{
  IoState_pushRetainPool(ioState);
  {
      IoCatch *catch = IoCatch_new(ioState);
      IoCatch_tryFunc_(catch, (IoCatchCallback *)DoIoString, 
	(void *)ioState, (void *)[s cString], (void *)0x0, &e);
      IoCatch_free(catch);
      if (e) IoException_printBackTrace(e);
  }
  IoState_popRetainPool(ioState);
  return self;
}

- lobby
{
  if (!lobby)
  { lobby = IoObjcBridge_proxyForIoObject_(sharedBridge, ioState->lobby); }
  return lobby;
}

@end
