@echo off
::
:: Generates the <Files> section for IoVM.vcproj, assuming that
:: all *.c and *.h in "dirIoVM" and "subdirs" are involved in the build.
::
:: Output to stdout.
::
:: -- Kevin Edwards
:: 2005-12-05 : created
::

set dirIo=..\..\..
set dirIoVM=%dirIo%\vm
set subdirs=base SkipDB

:: create IoVMCode.c if it doesn't already exist
set created_iovmcode=0
if not exist %dirIoVM%\IoVMCode.c (
  type nul >%dirIoVM%\IoVMCode.c
  set created_iovmcode=1
)

:: special characters (<>|...) are escaped using a caret (^)

:: Files Section
:: --------------------------------------
echo.^<Files^>

:: Source Files
:: --------------------------------------
echo.  ^<Filter
echo.    Name="Source Files"
echo.    Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
echo.    UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"^>
call :vcproj_files %dirIoVM%\*.c
for %%i in (%subdirs%) do call :vcproj_subfilter %%i *.c
echo.  ^</Filter^>

:: Header Files
:: --------------------------------------
echo.  ^<Filter
echo.    Name="Header Files"
echo.    Filter="h;hpp;hxx;hm;inl;inc;xsd"
echo.    UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"^>
call :vcproj_files %dirIoVM%\*.h
for %%i in (%subdirs%) do call :vcproj_subfilter %%i *.h
echo.  ^</Filter^>

echo.^</Files^>

if %created_iovmcode%==1 del %dirIoVM%\IoVMCode.c

goto :end
:: Subroutines:

:: vcproj_files(path_and_selection)
:vcproj_files
  for %%i in (%1) do echo.^<File RelativePath="%%i"^>^</File^>
  goto :end

:: vcproj_subfilter(name, selection)
:vcproj_subfilter
  echo.  ^<Filter Name="%1" Filter=""^>
  call :vcproj_files %dirIoVM%\%1\%2
  echo.  ^</Filter^>
  goto :end

:end

