
EditKnob := View clone do(
	size set(8, 8)
   	halfSize := size / 2
    
    newSlot("editController")

    resizeWidth  = 110
    resizeHeight = 110
    
    draw := method(
		glColor4d(0, 1, 0, .4)
		size drawQuad
		//glColor4d(0, 1, 0, .7)
		size drawLineLoopi
    )
    
    leftMouseDown := method(
    	//setMoveOffset
    	editController setMoveOffset
    	makeFirstResponder
    	//glutPostRedisplay
    )
    
    leftMouseMotion := method(
    	writeln("EditKnob leftMouseMotion ")
    	editController ?notifyMovedKnob(self)
    )
    
    leftMouseUp := method(releaseFirstResponder)
)

EditView := View clone do(
   	margin := vector(4, 4)
    contentView := nil

    resizeWidth  = 101
    resizeHeight = 101
    newSlot("originalResizeWidth")
    newSlot("originalResizeHeight")
    
    setContentView := method(cv,
    	contentView = cv
    	cv superview addSubview(self)
    	self setPosition(cv position - margin)
    	self setSize(cv size + margin * 2)
    	cv releaseFirstResponder
    	cv removeFromSuperview

		setOriginalResizeWidth(cv resizeWidth)
		
		setOriginalResizeWidth(cv resizeHeight)
		cv setResizeWidth(101)
		cv setResizeHeight(101)
		
		addSubview(cv)
		cv setPosition(margin)
		
		addSubview(EditKnob clone setEditController(self) setResizeWidth(110) setResizeHeight(110))
		addSubview(EditKnob clone setEditController(self) setResizeWidth(011) setResizeHeight(011) setPosition(size - EditKnob size))
		
		e := EditKnob clone setEditController(self) setResizeWidth(110) setResizeHeight(011)
		e position setY(size y - EditKnob size y)
		addSubview(e)
		e orderFront
		
		e := EditKnob clone setEditController(self) setResizeWidth(011) setResizeHeight(110)
		e position setX(size x - EditKnob size x)
		addSubview(e)
		e orderFront
		
    	glutPostRedisplay 
    )
    
    stopEditing := method(
    	removeSubview(contentView)
    	contentView setPosition(position + margin)
    	superview addSubview(contentView)
    	contentView setResizeWidth(self resizeWidth)
		contentView setResizeHeight(self resizeHeight)
		removeFromSuperview
    )
    
    /*
    keyboard := method(key,
    	if(key == 32, stopEditing)
    )
    */
    
    unselect := method(
    	stopEditing
    	glutPostRedisplay
    )
    
    //resizeWidth  = 011
    //resizeHeight = 011
    
    draw := method(
		glColor4d(0, 1, 0, .1)
		size drawQuad
		//glColor4d(0, 1, 0, .7)
		//size drawLineLoopi
		margin glTranslatei
		//contentView draw
		//contentView drawOutline
    )
    
    notifyMovedKnob := method(knob,
    	writeln("moving knob ", knob uniqueId)
		newPosition := superview screenToView(Mouse position clone) - moveOffset
		d := position - newPosition
		setPosition(newPosition)
		resizeBy(d x, d y)
    	glutPostRedisplay
    )
    
    leftMouseDown := method(
    	setMoveOffset
    	makeFirstResponder
    	glutPostRedisplay
    )
    
    leftMouseMotion := method(
    	moveWithMouse
    	//contentView setSize(contentView size + contentView position - position - halfSize)
    	//contentView setPosition(position + halfSize)
    	orderFront
    	glutPostRedisplay
    )
)