
// The Browser item protocol is:
// title, subitems, hasSubitems 

Directory do(
    title := method(name)
    subitems := method(
      items select(i, item, item name beginsWithSeq(".") == Nil)
    )
    object := Nil
    hasSubitems := 1
)

File do(
    title := method(name)
    subitems := method(List clone)
    hasSubitems := Nil
)

BrowserDelegate := Directory clone setPath("/")


Browser := HScrollArea clone do(
    protoName := "Browser"
    newSlot("columnWidth", 210)
    rootItem := BrowserDelegate clone
    textures := TextureGroup clone loadGroupNamed("Browser")
    newSlot("delegate", Nil)
    
    setRootItem := method(item, 
		rootItem = item
		updateColumns   
    )
    
    init := method(
		resend
		self stackView := HStackView clone
		stackView resizeWidth  = 110
		stackView resizeHeight = 101
		stackView setHeight(clipView height)
		clipView setDocumentView(stackView)
		addColumn
		updateColumns
    )
    
    addColumn := method(
		c := ColumnView clone
		c forceResizeTo(columnWidth, c height)
		c setDelegate(self)
		stackView addSubview(c)
		clipView update
		c
    )
    
    columns := method(stackView subviews)

    emptyColumns := method(
		columns foreach(column, 
			column empty
			column stackView organize
		)
    )
        
    updateColumns := method(
		emptyColumns
		columns first setRowObjects(rootItem subitems)
    )
    
    selectedItem := Nil
    
   columnSelected := method(column, item,
       selectedItem = item
       i := columns indexOf(column)
       while (columns size > i + 1, columns last removeFromSuperview)
       // > Mike Austin
       if (column == columns last and item object hasSubitems,
           addColumn setRowObjects(item object subitems)
       )
       // < Mike Austin
       if (delegate, delegate ?browserSelectedItem(item))
       scroller setValue(1) doAction
   )

    
    itemDoubleClick := method(item,
		write("Browser itemDoubleClick\n")
		if (delegate, delegate ?itemDoubleClick(item))
    )
    
    path := method(
		if (selectedItem, return selectedItem object path)
		rootItem path
    )
    
    draw := method(
    	textures draw(width, height)
    )
)
