
Button := Responder clone do(
    type := "Button"
    position set(100, 100)
    size set(100,32)

    textures := TextureSet clone

    setTexturesPath := method(path,
        textures = TextureSet clone openSet(path)
    )
    
    setTexturesPath("Buttons/Push")

    isSelected := Nil
    select     := method(isSelected = 1)
    unselect   := method(isSelected = Nil)    
    
    isDisabled := Nil
    disable    := method(isDisabled = 1)
    enable     := method(isDisabled = Nil)
    
    newSlot("title", "")
    widthOfTitle := method(font widthOfString(title))
    sizeToTitle := method(setWidth(widthOfTitle + 40); self)
    
    motionAction := Nil
    
    textColor := Color clone set(0,0,0,1)
    textColorSelected := Color clone set(0,0,0,1)
    textColorDisabled := Color clone set(.5,.5,.5,1)

    newSlot("image", Nil)
    newSlot("altImage", Nil)

    sizeToImage := method(
      if (image, size setWidth(image width) setHeight(image height+1))
    )

    textureWidth := method(width)
    textureHeight := method(height)
    
    draw := method(
		if (image, 
			if (isSelected == Nil) then (
				image draw
			) else (
				if (altImage, altImage, image) draw
			)
			return
		)
		
		w := size width
		h := size height
		
		if (isDisabled) then (
			textures disabled draw(textureWidth, textureHeight)
		) else (
			if (isSelected) then (
				textures active draw(textureWidth, textureHeight)
			) else (
				textures normal draw(textureWidth, textureHeight)
			)
		) 
		
		// draw label
		glPushMatrix
		textColor glColor
		//if (isSelected, textColorSelected glColor)
		if (isDisabled, textColorDisabled glColor)
		b := (((w - font widthOfString(title)) * .5) roundDown)
		glTranslated(b, 7, 0)
		font drawString(title)
		glPopMatrix
    )

    drawBackground := Nil
    drawOutline := Nil

    leftMouseDown := method(
		if (isDisabled, return)
		select
		glutPostRedisplay
    )

    leftMouseUp := method(
		if (isDisabled, return)
		if (isSelected, doAction)
		unselect
		glutPostRedisplay
    )

    leftMouseMotion := method(
		if (isDisabled, return)
		isSelected = if(screenHit, 1, Nil)
		//write("isSelected := ", isSelected, "\n")
		//if(isSelected, 
		if (actionTarget and motionAction, actionTarget perform(motionAction, self)) 
		//)
		glutPostRedisplay
    )
)
