
TextCell := Button clone do(
	arrow := ImageManager item("Arrows/Right")
	setHeight(20)
	resizeWidth = 101
	selectedColor := Color clone set(1,1,1,.3)
	
	draw := method(
		if (isSelected == 1, selectedColor glColor; size drawQuad)
		glPushMatrix
		textColor glColor
		glTranslated(3, 4, 0)
		font drawString(title)
		glPopMatrix
		if (object proto hasSlot("hasSubitems") == Nil, write("object = ", object, "\n") )
		if (object hasSubitems,
		glPushMatrix
		glTranslated(width - 16, 2, 0)
		arrow drawTexture
		glPopMatrix
		)
	)
	
	object := Nil
	
	setObject := method(obj,
		object = obj
		setTitle(object title)
		self
	)
	
	leftMouseDown := method(doAction)
	leftMouseUp := Nil
	
	select := method(isSelected = 1)
	unselect := method(isSelected = Nil)
	
	leftMouseDoubleClickDown := method(
		write("leftMouseDoubleClick\n")
		actionTarget ?itemDoubleClick(self)
	)
)
	
	// ------------------------------------------------------------------------
	
ColumnView := VScrollArea clone do(
	type := "ColumnView"
	textures := TextureGroup clone loadGroupNamed("ColumnView")
	selectedItem := Nil
	newSlot("delegate", Nil)
		
	init := method(
		resend
		self stackView := VStackView clone
		stackView resizeWidth = 101
		clipView setDocumentView(stackView)
		stackView resizeWidthTo(clipView width)
		addRow
	)
	
	rows := method(stackView subviews)
	
	empty := method(rows empty)
	
	addRow := method(
		stackView addSubview(TextCell clone setTitle("test"))
	)
	
	setRowObjects := method(objects,
		empty
		objects reverseForeach(obj, 
			if (obj == Nil, write("obj == Nil\n"); exit)
			t := TextCell clone setObject(obj)
			t resizeWidthTo(clipView width)
			t setActionTarget(self)
			t setAction("selectedItemAction")
			stackView addSubview(t)
		)
	)
	
	selectedItem := method(
		rows foreach(item, if (item isSelected, return item))
		Nil
	)
	
	selectedItemAction := method(anItem,
		rows foreach(item, item unselect)
		anItem select
		delegate ?columnSelected(self, anItem)
	)
	
	itemDoubleClick := method(item,
		write("ColumnView itemDoubleClick\n")
		delegate ?itemDoubleClick(item)
	)
	
	draw := method(
		resend 
		textures draw(width, height)
	)
)
