/*   
    copyright: Steve Dekorte, 2004. All rights reserved.
    license: See _BSDLicense.txt.

*/
#ifndef Word_DEFINED
#define Word_DEFINED 1

#include <stdio.h>
#include <sys/types.h> 

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
    PID_TYPE udbId;
    SkipDB *docs;
    size_t size;
} Word;

Word *Word_new(void);
void Word_free(Word *self);

void Word_addDocumentId_(Word *self, PID_TYPE docId);
void Word_removeDocumentId_(Word *self, PID_TYPE docId);

void Word_write(Word *self);
void Word_removeIfEmpty(Word *self);

#ifdef __cplusplus
}
#endif
#endif
