/*
the code: foo(a, "b"); bar(123, a)
would compile to:

iocode
s 3 foo
s 1 a
q 1 b
s 1 bar
n 123
-
1 ( 2 , 3 )
4 ( 5, 2 )
*/

#testMessage := message(foo(a, "b") baz; bar(123 neg, a); foo(a, "b") baz; bar(123 neg, a))
#testMessage := File clone setPath("pack.io") contents asMessage
#writeln(args)
testMessage := File clone setPath(args at(1)) contents asMessage

#Message symbol := method(if(cachedResult, cachedResult asString, name))
Message symbol := method(name)

symbols := Map clone

cachedTypeSwitch := Object clone do(
    Number := method(msg, "n" .. msg name)
    Sequence := method(msg, n := msg name; r := msg cachedResult; "q" .. n size .. " " .. n .. " " .. r size .. " " .. r)
    nil := method(msg, r := msg name; "s" .. r size .. " " .. r)

    m := message(Number(msg))
    dispatch := method(msg,
        m argAt(0) setCachedResult(msg)
        self doMessage(m setName(msg cachedResult type))
    )
)

processSymbol := method(msg,
    symbols hasKey(msg symbol) ifFalse(
        #write(symbols size + 1, " ", msg symbol, " ")
        write(cachedTypeSwitch dispatch(msg), "\n")
        symbols atPut(msg symbol, symbols size + 1)
    )
)

stack := list(testMessage)
while(stack size > 0,
    m := stack removeFirst
    processSymbol(m)
    stack appendSeq(m arguments)
    if(m attachedMessage, stack append(m attachedMessage))
    if(m nextMessage, stack append(m nextMessage))
)

write("-", "\n")

argSep := Object clone
lastArg := Object clone
nextMessage := Object clone
attachedMessage := Object clone

stack := list(testMessage)
while(stack size > 0,
    m := stack pop

    if(m == argSep,
        write(",")
        continue
    )
    if(m == lastArg,
        write(")")
        continue
    )
    if(m == attachedMessage,
        write(" ")
        continue
    )
    if(m == nextMessage,
        #write(";")
        write("\n")
        continue
    )

    write(symbols at(m symbol))
    #write(m symbol)

    if(m nextMessage, stack append(m nextMessage, nextMessage))
    if(m attachedMessage, stack append(m attachedMessage, attachedMessage))
    if(m arguments size > 0,
        write("(")
        stack append(lastArg)
        first := true
        m arguments reverseForeach(n,
            if(first, first = false, stack append(argSep))
            stack append(n)
        )
    )
)
write("\n")
